__global__ void RyrUpdate(FLOAT (*cd), int (*Nr), int (*Nrc), int (*Nri), int (*Nrr) ,FLOAT (*rfire), int (*dfun), unsigned (*seed_d1),unsigned (*seed_d2),unsigned (*seed_d3),unsigned (*seed_d4) , const FLOAT mdt, const unsigned int nxnynz){


const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
 
if (idx<nxnynz && dfun[idx]==1){


            const FLOAT beta=kam;
            const FLOAT delta=kbm;
            FLOAT alpha, gamma, sco, soc, scr, src, sri, sir, sio, soi, lam1,lam2,lam3,lam4,lam5,lam6,lamtot,rtest,tloc,wt,mlogr1,r1,r2;
            
 
   
            alpha=kap*POW(cd[idx],2);
            gamma=kbp*cd[idx];
            sco=Nrc[idx]*alpha;soc=Nr[idx]*beta;
            scr=Nrc[idx]*gamma;src=Nrr[idx]*kbmr2c;
            sri=Nrr[idx]*alpha;sir=Nri[idx]*beta;
            sio=Nri[idx]*delta;soi=Nr[idx]*gamma;
            lam1=sco+soc;lam2=lam1+scr;lam3=lam2+src;
            lam4=lam3+sri;lam5=lam4+sir;lam6=lam5+sio;
            lamtot=lam6+soi;

            rtest=rfire[idx]-lamtot*mdt;
            if (rtest<=0.0){              
              tloc=rfire[idx]/lamtot;
              r2=lamtot*HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
          
              if (r2<=sco ) { Nrc[idx]-=1;Nr[idx]+=1; }
              else if ( r2<=lam1 ) {Nrc[idx]+=1;Nr[idx]-=1;}
              else if ( r2<=lam2 ) { Nrc[idx]-=1;Nrr[idx]+=1; }
              else if ( r2<=lam3 ) { Nrr[idx]-=1;Nrc[idx]+=1; }
              else if ( r2<=lam4 ) { Nrr[idx]-=1;Nri[idx]+=1; }
              else if ( r2<=lam5 ) { Nri[idx]-=1;Nrr[idx]+=1; }
              else if ( r2<=lam6 ) { Nri[idx]-=1;Nr[idx]+=1; }
              else  {Nr[idx]-=1;Nri[idx]+=1;};

              sco=Nrc[idx]*alpha;soc=Nr[idx]*beta;
              scr=Nrc[idx]*gamma;src=Nrr[idx]*kbmr2c;
              sri=Nrr[idx]*alpha;sir=Nri[idx]*beta;
              sio=Nri[idx]*delta;soi=Nr[idx]*gamma;
              lam1=sco+soc;lam2=lam1+scr;lam3=lam2+src;
              lam4=lam3+sri;lam5=lam4+sir;lam6=lam5+sio;
              lamtot=lam6+soi;
        
              r1=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
              while (r1<=0.0){r1=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx); };
              mlogr1=-LOG(r1);
              wt=mlogr1/lamtot;
              tloc+=wt;
                        

              while (tloc<mdt){ 

                r2=lamtot*HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
                if (r2<=sco  ) { Nrc[idx]-=1;Nr[idx]+=1; }
                else if ( r2<=lam1 ) {Nrc[idx]+=1;Nr[idx]-=1;}
                else if ( r2<=lam2 ) { Nrc[idx]-=1;Nrr[idx]+=1; }
                else if ( r2<=lam3 ) { Nrr[idx]-=1;Nrc[idx]+=1; }
                else if ( r2<=lam4 ) { Nrr[idx]-=1;Nri[idx]+=1; }
                else if ( r2<=lam5 ) { Nri[idx]-=1;Nrr[idx]+=1; }
                else if ( r2<=lam6 ) { Nri[idx]-=1;Nr[idx]+=1; }
                else  {Nr[idx]-=1;Nri[idx]+=1;};

                sco=Nrc[idx]*alpha;soc=Nr[idx]*beta;
                scr=Nrc[idx]*gamma;src=Nrr[idx]*kbmr2c;
                sri=Nrr[idx]*alpha;sir=Nri[idx]*beta;
                sio=Nri[idx]*delta;soi=Nr[idx]*gamma;
                lam1=sco+soc;lam2=lam1+scr;lam3=lam2+src;
                lam4=lam3+sri;lam5=lam4+sir;lam6=lam5+sio;
                lamtot=lam6+soi;

                r1=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx);
                while (r1<=0.0){r1=HybridTaus(seed_d1,seed_d2,seed_d3,seed_d4,idx); };
                mlogr1=-LOG(r1);
                wt=mlogr1/lamtot;
                
                tloc+=wt;  
  
              };
              //rfire[idx]=mlogr1;
              rfire[idx]=mlogr1+lamtot*(-mdt+tloc-wt);
           }
           else {rfire[idx]=rtest;}; 





};

}


////////////////////////////////////////////////////////////////////////////////////////////


__global__ void RyrUpdate_ODE(FLOAT (*cd), int (*Nr), int (*Nrc), int (*Nri), int (*Nrr) , FLOAT (*Pro), FLOAT (*Pri),FLOAT (*Prc),int (*dfun), const FLOAT mdt, const unsigned int nxnynz){


const unsigned int idx=blockIdx.x*blockDim.x+threadIdx.x;  
 
if (idx<nxnynz && dfun[idx]==1){

            //const FLOAT nnr=Nryr;
            FLOAT alpha, gamma, Jpro,Jpri,Jprc;

            alpha=kap*POW(cd[idx],2);
            gamma=kbp*cd[idx];
 
			Jpro=( -(gamma+kam)*Pro[idx] +alpha*Prc[idx] +kbm*Pri[idx] );
	        Jpri=( -(kbm+kam)*Pri[idx] +gamma*Pro[idx] +alpha*(1-Pro[idx]-Prc[idx]-Pri[idx]) );
	        Jprc=( -(alpha+gamma)*Prc[idx] +kam*Pro[idx] +kbm*(1-Pro[idx]-Prc[idx]-Pri[idx]) );
	
	        Pro[idx]=Pro[idx]+mdt*Jpro;
            Pri[idx]=Pri[idx]+mdt*Jpri;
            Prc[idx]=Prc[idx]+mdt*Jprc;
            //if ( Pro[idx]>0 ) { Nr[idx]=int(Pro[idx]*nnr);} else { Nr[idx]=0;};
            //if ( Pri[idx]>0 ) { Nri[idx]=int(Pri[idx]*nnr);} else { Nri[idx]=0;};
            //if ( Prc[idx]>0 ) { Nrc[idx]=int(Prc[idx]*nnr);} else { Nrc[idx]=0;};
            //Nrr[idx]=1-Nr[idx]-Nri[idx]-Nrc[idx];
            //if (Nrr[idx]<0){Nrr[idx]=0;};

};

}



